

#include "p18f4550.h"


#pragma config WDT=OFF, LVP=OFF, DEBUG=OFF, MCLRE = ON
#pragma config FOSC = INTOSCIO_EC

#include <spi.h>
#include <delays.h>
 
#define INDICATOR1 PORTDbits.RD3
#define INDICATOR2 PORTDbits.RD2



//control the CD4051 demultiplexer chip set which string
// of LED boards are being send the data
void SetChannel(unsigned char input){
	//demultiplexer address is set by D7, D6, D5
	
	PORTD = PORTD&0b00011111;
	PORTD = PORTD | (input << 5);
}
	


void main(void){


    unsigned char rcount=0; //present LED colour values
    unsigned char gcount=0;
    unsigned char bcount=0;
    
    
    int ChannelNumber = 0;
    int ClusterNumber = 0;
    

    
	unsigned char i;

   	TRISD = 0; //initialize IO pins
	TRISC = 0;
	TRISB = 0;
    TRISA = 0;
    PORTD = 0;
	PORTC = 0;
	PORTB = 0;
	PORTA = 0;
	OSCTUNE = 0b00001111; 
	OSCCON  = 0b01110010;

    OpenSPI(SPI_FOSC_4, MODE_00, SMPEND); //initialize SPI


	while(1){ //repeat forever
			

		
		SetChannel(ChannelNumber);
		for(i  = 0; i < 120; i ++){
			if( i == ClusterNumber){
			
				WriteSPI(255); //red
				WriteSPI(255); //blue
				WriteSPI(255); //green
			} else {
				WriteSPI(0); //red
				WriteSPI(0); //blue
				WriteSPI(0); //green
			}
			
		}
		
		
		ClusterNumber++;
		if(ClusterNumber >= 120){
			ChannelNumber ++ ;
			if(ChannelNumber >= 8)
				ChannelNumber = 0; //reset
			ClusterNumber = 0;
		}
			
		for(i=0; i< 10; i++){ //wait ten seconds
			Delay10KTCYx(200);
		}

    }
}